'use strict';
/*global XR */

/**
 * Created by x.Laoxu on 5/1/16.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});
var Subscribe = {
    create: function create(context) {
        context._AltMixinRegistry = context._AltMixinRegistry || [];
    },

    add: function add(context, store, handler) {
        context._AltMixinRegistry.push(store.listen(handler));
    },

    destroy: function destroy(context) {
        context._AltMixinRegistry.forEach(function (f) {
            return f();
        });
        context._AltMixinRegistry = [];
    },

    listeners: function listeners(context) {
        return context._AltMixinRegistry;
    }
};

exports.default = Subscribe;