'use strict';

/**
 * Created by x on 12/1/15.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RouteHandler = function () {
    function RouteHandler() {
        _classCallCheck(this, RouteHandler);

        this.historyListener = [];
        this.location = null;
    }

    _createClass(RouteHandler, [{
        key: 'setEntryLocation',
        value: function setEntryLocation(location) {
            this.entry = location;
            //console.log('entry', this.entry);
            this.setEntryLocation = function () {
                return null;
            };
        }

        //url_config 表示router中URL_CONFIG

    }, {
        key: 'init',
        value: function init(history, url_config) {
            var _this = this;

            this.history = history;

            this._to = {};
            this._get = url_config;
            //枚举路由设置对象URL_GETTER
            Object.keys(this._get).map(function (n) {
                //扩展this._to对象 列子: this.to.period
                _this._to[n] = function () {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                        args[_key] = arguments[_key];
                    }

                    _this._toInvoke.apply(_this, [n].concat(args));
                };
            });

            this._gobackFix();

            this.history.listen(function (location) {
                _this.setEntryLocation(location);
                _this.location = location;
                _this.historyListener.forEach(function (listener) {
                    setTimeout(function () {
                        return listener(location);
                    }, 0);
                });
            });
        }
    }, {
        key: '_gobackFix',
        value: function _gobackFix() {
            var _this2 = this;

            this.length = 0;
            this.urlBackHandle = function (location) {
                //console.log(this.length);
                if (location.action === 'POP') {
                    _this2.length = Math.max(--_this2.length, 0);
                } else {
                    _this2.length++;
                }
                //console.log(this.length, location);
            };
            this.addListener(this.urlBackHandle);
        }
    }, {
        key: 'removeListener',
        value: function removeListener(listener) {
            // console.log(this.historyListener.length);
            this.historyListener = this.historyListener.filter(function (l) {
                return l != listener;
            });
            // console.log(this.historyListener.length);
        }
    }, {
        key: 'addListener',
        value: function addListener(listener) {
            var _this3 = this;

            this.historyListener.push(listener);
            /**
             * 如果,this.history.listen 执行过,第一次添加时,会执行listener
             */
            if (this.location) {
                setTimeout(function () {
                    return listener(_this3.location);
                }, 0);
            }
        }
    }, {
        key: '_toInvoke',
        value: function _toInvoke(n) {
            var _get;

            for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                args[_key2 - 1] = arguments[_key2];
            }

            var url = (_get = this._get)[n].apply(_get, args);
            // if (x.isWeiXin() && n == 'cart') {
            //     location.pathname = url;
            //     return;
            // }
            this.goto.apply(this, [url].concat(args));
        }
    }, {
        key: 'goIndex',
        value: function goIndex() {
            this.goto('/');
        }
    }, {
        key: 'goto',
        value: function goto(url) {
            // console.log(url);
            // if (XSpaceHost.routeInterceptor(this.location, url)) {
            //     return false;
            // }


            if (url && url.indexOf('http') === 0) {
                x.window.goto(url);
                return;
            } else {

                var splistUrl = url.split('?');

                var _ = {
                    pathname: splistUrl[0],
                    search: splistUrl.length == 2 ? '?' + splistUrl[1] : ''
                };

                this.history.push(_);
            }
        }
    }, {
        key: 'goBack',
        value: function goBack() {
            if (this.length == 0 && window.history && window.history.length > this.length) {
                this.goIndex();
                return;
            }
            this.history.goBack();
        }
    }, {
        key: 'replace',
        value: function replace(url) {
            this.history.replace(url);
        }
    }, {
        key: 'to',
        get: function get() {
            return this._to;
        }
    }, {
        key: 'get',
        get: function get() {
            return this._get;
        }
    }]);

    return RouteHandler;
}();

var R = new RouteHandler();
exports.default = R;