'use strict';
/*global XR*/

/**
 * Created by x.Laoxu on 24/08/2016.
 */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _LocalStorage = require('./LocalStorage');

var _LocalStorage2 = _interopRequireDefault(_LocalStorage);

var _ApiError = require('./ApiError');

var _ApiError2 = _interopRequireDefault(_ApiError);

var _Fetcher = require('./Fetcher');

var _Fetcher2 = _interopRequireDefault(_Fetcher);

var _RouteHandler = require('./RouteHandler');

var _RouteHandler2 = _interopRequireDefault(_RouteHandler);

var _AsyncLoader = require('./AsyncLoader');

var _AsyncLoader2 = _interopRequireDefault(_AsyncLoader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    R: _RouteHandler2.default,
    AsyncLoader: _AsyncLoader2.default,
    DB: _LocalStorage2.default,
    Fetcher: _Fetcher2.default,
    APIError: _ApiError2.default
};