'use strict';
/*global XR */

/**
 * Created by x.Laoxu on 5/1/16.
 */

const Subscribe = {
    create: function (context) {
        context._AltMixinRegistry = context._AltMixinRegistry || [];
    },

    add: function (context, store, handler) {
        context._AltMixinRegistry.push(store.listen(handler));
    },

    destroy: function (context) {
        context._AltMixinRegistry.forEach(f=>f());
        context._AltMixinRegistry = [];
    },

    listeners: function (context) {
        return context._AltMixinRegistry;
    }
};

export default Subscribe;