'use strict';
/*global XR */

/**
 * Created by x.Laoxu on 5/1/16.
 */

import Alt from 'alt';

const alt = new Alt();

export class BaseActions {
    constructor(clsName) {
        this.name = clsName;
    }
}

export class BaseStore {
    constructor() {
        const action = this.constructor.action;
        action && this.bindActions(action);
        this.__init();
    }

    __init() {

    }
}

export const bindAlt = (actionCls, storeCls)=> {
    storeCls.action = alt.createActions(actionCls);
    const store = alt.createStore(storeCls, storeCls.action.name + 'Store');

    return {
        Store: store,
        Action: store.action
    }
};
//
// export const createActions = (action)=> {
//     return alt.createActions(action);
// };


// export default alt;